#include <linuxmt/types.h>
#include <linuxmt/sched.h>

#include <arch/segment.h>

/* This is a generic lib function... */

void *memcpy(dest, src, len)
void *dest;
void *src;
__uint len;
{
	int c;

	for (c = 0; c < len; c++)
		((__pu8)dest)[c] = ((__pu8)src)[c];

	return dest;
}

void setup_arch(start,end)
int *start;
int *end;
{
	/*
	 *	Now create task 0 to be ourself. Set the kernel SP,
	 *	as we will need this in interrupts.
	 */	

 	task[0].state = TASK_RUNNING;
	task[0].t_count=0;
	task[0].t_priority=0;
	task[0].t_regs.sp=4096;		/* Kernel init is allowed 4K of nonspace */
	task[0].t_priority=10;
	task[0].t_count=0;
	
	current = &task[0];
	curnum = 0;
	
	/*
	 *	Mark tasks 1-31 as not in use.
	 */
	for(ct=1;ct<MAX_TASKS;ct++)
		task[ct].state=TASK_UNUSED;
	/*
	 *	Fill in the MM numbers - really ought to be in mm not kernel ?
	 *	640K base mem is still hard coded (messy)
	 */
	 
	*end = END_OF_TPA();
	*start = _end;				/* Linker symbol */
}

