/*
 *	CP/M BIOS console
 */

#include <linuxmt/types.h>
#include <linuxmt/errno.h>
#include <linuxmt/fcntl.h>
#include <linuxmt/fs.h>

#include <arch/cpmbios.h>
 
#asm
callhl:
	JP	(HL)
#endasm
	
void bios_charout(c)
char c;
{
	char tmp;	/* Ends up in L */
	bios_mode=1;
	tmp=c;
#asm
	LD	C,L	* Character to output
	LD	HL,(1)	* BIOS address
	ADD	HL,9	* CONOUT address
	CALL	callhl	* CALL (HL) trick
#endasm
	bios_mode=0;
}

int bioscon_lseek(inode,file,offset,origin)
struct inode *inode;
struct file *file;
off_t offset;
int origin;
{
	return -ESPIPE;
}

int bioscon_write(inode,file,buf,count)
struct inode *inode;
struct file *file;
char *buf;
int count;
{
	int len=0;
	while(len<count)
	{
		bios_charout(*buf++);
	}
	return count;
}

int bioscon_read(inode,file,buf,count)
struct inode *inode;
struct file *file;
char *buf;
int count;
{
	if(file->f_flags&O_NONBLOCK)
		return -EWOULDBLOCK;
	return -EINVAL;
}

void bioscon_release(inode,file)
struct inode *inode;
struct file *file;
{
	return;
}

int bioscon_open(inode,file)
struct inode *inode;
struct file *file;
{
	int minor = MINOR(inode->i_rdev);
	if(minor!=0)
		return -ENODEV;
	return 0;
}


static struct file_operations bioscon_ops=
{
	bioscon_lseek,
	bioscon_read,
	bioscon_write,
	NULL,
	NULL,			/* Write select later */
	NULL,			/* Write ioctl later */
	bioscon_open,		/* Open the bios console */
	bioscon_release,	/* Close the bios console */
	NULL,			/* Fsync */
	NULL,			/* No media */
	NULL			/* No media */
};

void init_bioscon()
{
	printk("Console: BIOS\n");
}

